// ConvertAudioFileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ConvertAudioFile.h"
#include "ConvertAudioFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "waveformat.h"

enum __MIDL___MIDL_itf_WaveExControl_0000_0001
    {	WF_PCM_8kHz8BitMono	= 4,
	WF_PCM_8kHz8BitStereo	= WF_PCM_8kHz8BitMono + 1,
	WF_PCM_8kHz16BitMono	= WF_PCM_8kHz8BitStereo + 1,
	WF_PCM_8kHz16BitStereo	= WF_PCM_8kHz16BitMono + 1,
	WF_PCM_11kHz8BitMono	= WF_PCM_8kHz16BitStereo + 1,
	WF_PCM_11kHz8BitStereo	= WF_PCM_11kHz8BitMono + 1,
	WF_PCM_11kHz16BitMono	= WF_PCM_11kHz8BitStereo + 1,
	WF_PCM_11kHz16BitStereo	= WF_PCM_11kHz16BitMono + 1,
	WF_PCM_12kHz8BitMono	= WF_PCM_11kHz16BitStereo + 1,
	WF_PCM_12kHz8BitStereo	= WF_PCM_12kHz8BitMono + 1,
	WF_PCM_12kHz16BitMono	= WF_PCM_12kHz8BitStereo + 1,
	WF_PCM_12kHz16BitStereo	= WF_PCM_12kHz16BitMono + 1,
	WF_PCM_16kHz8BitMono	= WF_PCM_12kHz16BitStereo + 1,
	WF_PCM_16kHz8BitStereo	= WF_PCM_16kHz8BitMono + 1,
	WF_PCM_16kHz16BitMono	= WF_PCM_16kHz8BitStereo + 1,
	WF_PCM_16kHz16BitStereo	= WF_PCM_16kHz16BitMono + 1,
	WF_PCM_22kHz8BitMono	= WF_PCM_16kHz16BitStereo + 1,
	WF_PCM_22kHz8BitStereo	= WF_PCM_22kHz8BitMono + 1,
	WF_PCM_22kHz16BitMono	= WF_PCM_22kHz8BitStereo + 1,
	WF_PCM_22kHz16BitStereo	= WF_PCM_22kHz16BitMono + 1,
	WF_PCM_24kHz8BitMono	= WF_PCM_22kHz16BitStereo + 1,
	WF_PCM_24kHz8BitStereo	= WF_PCM_24kHz8BitMono + 1,
	WF_PCM_24kHz16BitMono	= WF_PCM_24kHz8BitStereo + 1,
	WF_PCM_24kHz16BitStereo	= WF_PCM_24kHz16BitMono + 1,
	WF_PCM_32kHz8BitMono	= WF_PCM_24kHz16BitStereo + 1,
	WF_PCM_32kHz8BitStereo	= WF_PCM_32kHz8BitMono + 1,
	WF_PCM_32kHz16BitMono	= WF_PCM_32kHz8BitStereo + 1,
	WF_PCM_32kHz16BitStereo	= WF_PCM_32kHz16BitMono + 1,
	WF_PCM_44kHz8BitMono	= WF_PCM_32kHz16BitStereo + 1,
	WF_PCM_44kHz8BitStereo	= WF_PCM_44kHz8BitMono + 1,
	WF_PCM_44kHz16BitMono	= WF_PCM_44kHz8BitStereo + 1,
	WF_PCM_44kHz16BitStereo	= WF_PCM_44kHz16BitMono + 1,
	WF_PCM_48kHz8BitMono	= WF_PCM_44kHz16BitStereo + 1,
	WF_PCM_48kHz8BitStereo	= WF_PCM_48kHz8BitMono + 1,
	WF_PCM_48kHz16BitMono	= WF_PCM_48kHz8BitStereo + 1,
	WF_PCM_48kHz16BitStereo	= WF_PCM_48kHz16BitMono + 1,
	WF_TrueSpeech_8kHz1BitMono	= WF_PCM_48kHz16BitStereo + 1,
	WF_CCITT_ALaw_8kHzMono	= WF_TrueSpeech_8kHz1BitMono + 1,
	WF_CCITT_ALaw_8kHzStereo	= WF_CCITT_ALaw_8kHzMono + 1,
	WF_CCITT_ALaw_11kHzMono	= WF_CCITT_ALaw_8kHzStereo + 1,
	WF_CCITT_ALaw_11kHzStereo	= WF_CCITT_ALaw_11kHzMono + 1,
	WF_CCITT_ALaw_22kHzMono	= WF_CCITT_ALaw_11kHzStereo + 1,
	WF_CCITT_ALaw_22kHzStereo	= WF_CCITT_ALaw_22kHzMono + 1,
	WF_CCITT_ALaw_44kHzMono	= WF_CCITT_ALaw_22kHzStereo + 1,
	WF_CCITT_ALaw_44kHzStereo	= WF_CCITT_ALaw_44kHzMono + 1,
	WF_CCITT_uLaw_8kHzMono	= WF_CCITT_ALaw_44kHzStereo + 1,
	WF_CCITT_uLaw_8kHzStereo	= WF_CCITT_uLaw_8kHzMono + 1,
	WF_CCITT_uLaw_11kHzMono	= WF_CCITT_uLaw_8kHzStereo + 1,
	WF_CCITT_uLaw_11kHzStereo	= WF_CCITT_uLaw_11kHzMono + 1,
	WF_CCITT_uLaw_22kHzMono	= WF_CCITT_uLaw_11kHzStereo + 1,
	WF_CCITT_uLaw_22kHzStereo	= WF_CCITT_uLaw_22kHzMono + 1,
	WF_CCITT_uLaw_44kHzMono	= WF_CCITT_uLaw_22kHzStereo + 1,
	WF_CCITT_uLaw_44kHzStereo	= WF_CCITT_uLaw_44kHzMono + 1,
	WF_ADPCM_8kHzMono	= WF_CCITT_uLaw_44kHzStereo + 1,
	WF_ADPCM_8kHzStereo	= WF_ADPCM_8kHzMono + 1,
	WF_ADPCM_11kHzMono	= WF_ADPCM_8kHzStereo + 1,
	WF_ADPCM_11kHzStereo	= WF_ADPCM_11kHzMono + 1,
	WF_ADPCM_22kHzMono	= WF_ADPCM_11kHzStereo + 1,
	WF_ADPCM_22kHzStereo	= WF_ADPCM_22kHzMono + 1,
	WF_ADPCM_44kHzMono	= WF_ADPCM_22kHzStereo + 1,
	WF_ADPCM_44kHzStereo	= WF_ADPCM_44kHzMono + 1,
	WF_GSM610_8kHzMono	= WF_ADPCM_44kHzStereo + 1,
	WF_GSM610_11kHzMono	= WF_GSM610_8kHzMono + 1,
	WF_GSM610_22kHzMono	= WF_GSM610_11kHzMono + 1,
	WF_GSM610_44kHzMono	= WF_GSM610_22kHzMono + 1
    }	WAVEFORMAT_INDEX;


/////////////////////////////////////////////////////////////////////////////
// CConvertAudioFileDlg dialog

CConvertAudioFileDlg::CConvertAudioFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConvertAudioFileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConvertAudioFileDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CConvertAudioFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConvertAudioFileDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_Progressbar);
	DDX_Control(pDX, IDC_EDSOURCE, m_EDSource);
	DDX_Control(pDX, IDC_EDOUTFILE, m_EDOutFile);
	DDX_Control(pDX, IDC_EDFORMAT, m_EDFormat);
	DDX_Control(pDX, ID_CONVERT, m_BnConvert);
	DDX_Control(pDX, IDC_WAVEEXCTRL1, m_WaveEx);
	DDX_Control(pDX, IDC_COMMONDIALOG1, m_OpenFileDlg);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CConvertAudioFileDlg, CDialog)
	//{{AFX_MSG_MAP(CConvertAudioFileDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BNBROWSE, OnBnbrowse)
	ON_BN_CLICKED(IDC_BNSELECT, OnBnselect)
	ON_BN_CLICKED(ID_CONVERT, OnConvert)
	ON_EN_CHANGE(IDC_EDSOURCE, OnChangeEdsource)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConvertAudioFileDlg message handlers

BOOL CConvertAudioFileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_EDOutFile.SetWindowText("out.wav");
	m_BnConvert.EnableWindow(FALSE);
	
	// ---- Set GSM 8khz as the default output format
	VARIANT vt;
	VariantClear(&vt);
	vt.vt=VT_I4;
	vt.intVal=WF_GSM610_8kHzMono;
	m_WaveEx.GetRecordFormat().SetFormatID(vt);  
	
	m_EDFormat.SetWindowText(m_WaveEx.GetRecordFormatName());

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CConvertAudioFileDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CConvertAudioFileDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CConvertAudioFileDlg::OnBnbrowse() 
{
	// TODO: Add your control notification handler code here
	m_OpenFileDlg.ShowOpen();
	m_EDSource.SetWindowText(m_OpenFileDlg.GetFileName());
}

void CConvertAudioFileDlg::OnBnselect() 
{
	// TODO: Add your control notification handler code here
 m_WaveEx.GetRecordFormat().ShowSelectionDialog("select the destination format");
 m_EDFormat.SetWindowText(m_WaveEx.GetRecordFormatName());
	
}

void CConvertAudioFileDlg::OnConvert() 
{
	// TODO: Add your control notification handler code here
	CString szSrcFile, szDestFile;
	m_EDSource.GetWindowText(szSrcFile);
	m_EDOutFile.GetWindowText(szDestFile);
	
	m_WaveEx.GetPlaybackFormat().SetFormatIndex(WF_CCITT_ALaw_8kHzMono);
	m_WaveEx.GetRecordFormat().SetFormatIndex(WF_GSM610_8kHzMono);

	if (m_WaveEx.ConvertFile(szSrcFile , szDestFile)) 
	{
		MessageBox("Convert Done. ");
		m_Progressbar.SetPos(0);
	}
}

void CConvertAudioFileDlg::OnChangeEdsource() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	m_BnConvert.EnableWindow(m_EDSource.GetWindowTextLength()>0);
}

BEGIN_EVENTSINK_MAP(CConvertAudioFileDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CConvertAudioFileDlg)
	ON_EVENT(CConvertAudioFileDlg, IDC_WAVEEXCTRL1, 7 /* OnConvertProgress */, OnOnConvertProgressWaveexctrl1, VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CConvertAudioFileDlg::OnOnConvertProgressWaveexctrl1(long nProgress, long nProgressMax) 
{
	// TODO: Add your control notification handler code here
	int newPos=100*nProgress/nProgressMax;
	m_Progressbar.SetPos(newPos);	
}
